import br.lavid.hn2n.net.CommunicationLink;
import br.lavid.hn2n.net.LinkTCP;
import br.lavid.hn2n.net.Package;
import br.lavid.hn2n.process.LinkObserver;
import br.lavid.hn2n.server.SlaveServer;

/**
 * Classe que implementa um LinkObserver, e  reponsvel por monitorar as mensagens
 * que chegam a este servidor, envidas pelos clientes
 * @author aquiles
 *
 */
public class ServerProcess implements LinkObserver {

	/**
	 * Esse mtodo  chamado automaticamente pelo H-N2N quando uma mensagem chega
	 * pela rede, para o dono deste process
	 */
	public boolean update(CommunicationLink link, Package pacote) {
		//recupera quem  o escravo que esta responsvel pelo cliente deste link.
		//Cada cliente tem um escravo associado no lado servidor.
		SlaveServer slave = (SlaveServer)((LinkTCP)link).getSlaveNetProcess();
		//Imprime o conteudo da mensagem na saida padro.
		System.out.println("Servidor recebeu:"+((MChat)pacote.getContent()).getMsg());
		//Quando o servidor receber uma mensagem do cliente, e e faz o repasse para
		//todos os outros clientes, chamando o mtodo relay()
		slave.getGroupServer().relay(pacote, slave);
		return false;
	}

}
